//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiUtilisateur {

    /** Permet d'ajouter un utilisateur au sein d'un foyer */
    public enum PostApiUtilisateurAjouter {

        public static let service = APIService<Response>(id: "postApiUtilisateurAjouter", tag: "Api Utilisateur", method: "POST", path: "/apiUtilisateur/ajouter", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idFoyer: String

                public var nom: String

                public var prenom: String

                public init(idFoyer: String, nom: String, prenom: String) {
                    self.idFoyer = idFoyer
                    self.nom = nom
                    self.prenom = prenom
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiUtilisateurAjouter.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idFoyer: String, nom: String, prenom: String) {
                let options = Options(idFoyer: idFoyer, nom: nom, prenom: prenom)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idFoyer"] = options.idFoyer
                params["nom"] = options.nom
                params["prenom"] = options.prenom
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = IdentifiantUtilisateur

            /** Succes */
            case status200(IdentifiantUtilisateur)

            /** Erreur */
            case status400

            /** Erreur */
            case status500

            public var success: IdentifiantUtilisateur? {
                switch self {
                case .status200(let response): return response
                default: return nil
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                default: return ()
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                case .status400: return 400
                case .status500: return 500
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                case .status400: return false
                case .status500: return false
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                case 400: self = .status400
                case 500: self = .status500
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
